// C Source File
// Created 1/1/2006; 10:06:29 AM
// Tron v1.00 - By Tyler Cassidy
// (C) Copyright 2006 Tyler Cassidy. All Rights Reserved.
// Email: altadogsledder89@yahoo.ca
//        tyler@tylerc.org
// Website: none yet
// ** Note: I will not be responsible for anything that this game game does to your calculator!

// Definitions
// #define MIN_AMS 200 // Only Enable this if you are not using TIGCC IDE

// Header Files
#include <tigcclib.h> // All TIGCC Header Files
#include "tron.h" // Tron Header File
#include "engine.h" // Game Engine Header File

// Load Settings Function - void FE_LoadSettings(void)
void FE_LoadSettings(void) {
  // Lets setup some Structures
  GAMESAVE *GameLoad;
  
  // Lets make some stuff
  SYM_ENTRY *LoadEntry; // Make a SYM_ENTRY
  
  // Find Save File
  LoadEntry = SymFindPtr(SYMSTR("tronsave"), 0);
  
  // Does Save File Exist?
  if (!LoadEntry) return; // File doesnt Exist.
  
  // Does the Save File have usable data in it?
  if (!LoadEntry->handle) return; // Non usable data
  
  // Dereference File Data
  GameLoad = HeapDeref(LoadEntry->handle);
  
  // Copy data from Save File
  memcpy(&gamehighscores, &GameLoad->game_highscores, sizeof(GAMEHIGHSCORES)); // Load Game Scores
  
	// End of Load Settings Function
}

// Save Settings Function - void FE_SaveSettings(void)
void FE_SaveSettings(void) {
  // Lets setup some structures
  GAMESAVE *GameSave;
  
  // Lets startup some stuff
  HSym SaveSym; // Symbol Identifier
  SYM_ENTRY *SaveEntry; // Startup a SYM_ENTRY
  HANDLE SaveHandle; // Startup a Memory Allocation Block

  // Lets Unarchive the Variable
  EM_moveSymFromExtMem(SYMSTR("tronsave"), HS_NULL);
    
  // Lets now Delete the Original VAT Symbol
  SymDel(SYMSTR("tronsave"));
  
  // Lets start a New VAT Symbol
  SaveSym = SymAdd(SYMSTR("tronsave"));
  
  // Could the File be added?
  if (!SaveSym.folder) return; // Exit Out, File could not be added
  
  // Lets startup the Handle with a Heap Allocation
  SaveHandle = HeapAlloc(sizeof(GAMESAVE));
  
  // If Allocation was a failure, exit process
  if (!SaveHandle) {
  	SymDel(SYMSTR("tronsave"));
  	return;
  }
  
  // Lets dereference the Heap Now
  GameSave = HeapDeref(SaveHandle);
  
  // Lets set Filesize
  GameSave->filesize = sizeof(GAMEHIGHSCORES) + 7; // 4 means "TRON" Tag Type, 2 for zeros, 1 for OTH_TAG
  
  // Lets Save Scores Now
  memcpy(&GameSave->game_highscores, &gamehighscores, sizeof(GAMEHIGHSCORES)); // Game Highscores
  
  // Lets setup the Type Tag Now
  memcpy(GameSave->typetag, "\0TRON\0\xF8", 7);
  
  // Set SYM_ENTRY handle with handle
  SaveEntry = DerefSym(SaveSym);
  SaveEntry->handle = SaveHandle;
  
  // Lets Archive the Save File
  EM_moveSymToExtMem(SYMSTR("tronsave"), HS_NULL);
  
  // End of Save Settings Function
}